/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */

package shapes.editparts.policies;

import com.metys.merlin.generation.gef.commands.CreateConnectionCommand;
import com.metys.merlin.generation.gef.commands.ReconnectSourceCommand;
import com.metys.merlin.generation.gef.commands.ReconnectTargetCommand;

import com.metys.merlin.generation.gef.model.ELink;
import com.metys.merlin.generation.gef.model.ENode;

import com.metys.merlin.generation.gef.policies.ENodeGraphicalNodeEditPolicy;

import org.eclipse.gef.commands.Command;

import org.eclipse.gef.requests.CreateConnectionRequest;
import org.eclipse.gef.requests.ReconnectRequest;

import shapes.editparts.ShapeEditPart;

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public abstract class ShapeGraphicalNodeEditPolicy extends ENodeGraphicalNodeEditPolicy{
  
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Command getConnectionCompleteCommand(CreateConnectionRequest request) {
    if (request.getStartCommand() instanceof CreateConnectionCommand) {
      CreateConnectionCommand cmd = (CreateConnectionCommand) request.getStartCommand();
      ShapeEditPart targetNodeEditPart = (ShapeEditPart) getHost();
      ENode target = targetNodeEditPart.getENode();
      ELink link = cmd.getLink();
      if (acceptLinkAsTarget(target, link)) {
        cmd.setTargetNodeEditPart(targetNodeEditPart);
        return cmd;
      }
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Command getConnectionCreateCommand(CreateConnectionRequest request) {
    ShapeEditPart sourceNodeEditPart = (ShapeEditPart) getHost();
    ENode source = sourceNodeEditPart.getENode();
    ELink link = (ELink) request.getNewObject();
    if (acceptLinkAsSource(source, link)) {
      CreateConnectionCommand cmd = new CreateConnectionCommand(sourceNodeEditPart, link);
      request.setStartCommand(cmd);
      return cmd;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Command getReconnectSourceCommand(ReconnectRequest request) {
    ShapeEditPart sourceNodeEditPart = (ShapeEditPart) getHost();
    ELink link = (ELink) request.getConnectionEditPart().getModel();
    ENode source = sourceNodeEditPart.getENode();
    if (acceptLinkAsSource(source, link)) {
      ReconnectSourceCommand cmd = new ReconnectSourceCommand(sourceNodeEditPart, link);
      return cmd;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Command getReconnectTargetCommand(ReconnectRequest request) {
    ShapeEditPart targetNodeEditPart = (ShapeEditPart) getHost();
    ELink link = (ELink) request.getConnectionEditPart().getModel();
    ENode target = targetNodeEditPart.getENode();
    if (acceptLinkAsTarget(target, link)) {
      ReconnectTargetCommand cmd = new ReconnectTargetCommand(targetNodeEditPart, link);
      return cmd;
    }
    return null;
  }
  
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean acceptLinkAsTarget(ENode target, ELink link) {
    return target.acceptLinkAsTarget(link);
  }
  
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean acceptLinkAsSource(ENode source, ELink link) {
    return source.acceptLinkAsSource(link);
  }
}